Description

Hi fellow Rubyists,

I saw methods defined directly in included block when using Concern several times.

module AModule

  extend ActiveSupport::Concern

  included do

   # this is BAD

   def a_method

    end

  end

end

 It is a bad practice and it breaks things, all instance methods should go to the AModule, and all class methods to a ClassMethods

module.

- It dynamically creates methods in each class, they are not shared through module, it is slow.

- It cannot be accessed for extension, there is no module to include to.

- it breaks `super` calls.

We should avoid using this and go for:

module AModule

  extend ActiveSupport::Concern

  included do

    # e.g.

    has_one :user

  end

  module ClassMethods

    def a_method

    end

  end

end

 Thanks.

I'll create issue to remove these bad definitions.

Petr

Related issues:

Related to Katello - Bug #6317: rake katello:reindex fails with NoMethodError... Closed 06/20/2014

Copied to Foreman - Refactor #5714: Remove method definitions from included b... New 05/14/2014
Associated revisions

Revision da7584bd - 06/19/2014 04:37 PM - Eric Helms

Fixes #5713: Removes instance method declarations from included block of concerns.

Revision 9e818043 - 06/20/2014 11:15 AM - Eric Helms

Merge pull request #4108 from ehelms/fixes-5713

Fixes #5713: Removes instance method declarations from included block of...

History

#1 - 05/14/2014 08:50 AM - Petr Chalupa

- Description updated

#2 - 05/14/2014 08:51 AM - Petr Chalupa

- Tracker changed from Bug to Refactor

#3 - 05/14/2014 08:52 AM - Petr Chalupa

- Copied to Refactor #5714: Remove method definitions from included block when using Concern added

#4 - 06/20/2014 11:17 AM - Eric Helms

- Target version set to 48

- Triaged changed from No to Yes

#5 - 06/20/2014 11:52 AM - Eric Helms

- Status changed from New to Closed

- % Done changed from 0 to 100

Applied in changeset katello|commit:da7584bd9c6a14d3c641cb8777a58b4a8211cd26.

#6 - 06/20/2014 04:13 PM - David Davis

- Related to Bug #6317: rake katello:reindex fails with NoMethodError: undefined method `delete_index' for Katello::PuppetModule:Class  added

#7 - 08/22/2014 08:23 AM - Eric Helms

- translation missing: en.field_release set to 13
